package com.ccnode.codegenerator.view.h;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.ccnode.codegenerator.ae.D;
import com.ccnode.codegenerator.ae.W;
import com.ccnode.codegenerator.dom.model.Mapper;
import com.ccnode.codegenerator.view.h.q;
import com.google.common.collect.Maps;
import com.google.common.collect.Sets;
import com.intellij.lang.injection.InjectedLanguageManager;
import com.intellij.openapi.application.ApplicationManager;
import com.intellij.openapi.command.WriteCommandAction;
import com.intellij.openapi.editor.Editor;
import com.intellij.openapi.project.Project;
import com.intellij.openapi.util.TextRange;
import com.intellij.openapi.vfs.VirtualFile;
import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiFile;
import com.intellij.psi.PsiLanguageInjectionHost;
import com.intellij.psi.PsiReference;
import com.intellij.psi.search.GlobalSearchScope;
import com.intellij.psi.search.SearchScope;
import com.intellij.psi.search.searches.ReferencesSearch;
import com.intellij.psi.xml.XmlAttribute;
import com.intellij.psi.xml.XmlAttributeValue;
import com.intellij.psi.xml.XmlTag;
import com.intellij.psi.xml.XmlTagValue;
import com.intellij.psi.xml.XmlText;
import com.intellij.util.IncorrectOperationException;
import com.intellij.util.Query;
import com.intellij.util.xml.DomFileElement;
import com.intellij.util.xml.DomService;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.stream.Collectors;
import org.jetbrains.annotations.NotNull;

public class p extends q {
  public void invoke(@NotNull Project paramProject, Editor paramEditor, @NotNull PsiElement paramPsiElement) throws IncorrectOperationException {
    boolean bool = ApplicationManager.getApplication().isWriteAccessAllowed();
    if (!bool)
      return; 
    PsiLanguageInjectionHost psiLanguageInjectionHost = InjectedLanguageManager.getInstance(paramProject).getInjectionHost(paramPsiElement);
    XmlText xmlText = (XmlText)psiLanguageInjectionHost;
    XmlTag xmlTag = D.a.a((PsiElement)xmlText, true);
    if (xmlTag == null)
      return; 
    XmlAttribute xmlAttribute = xmlTag.getAttribute("id");
    if (xmlAttribute == null) {
      a(xmlTag);
      return;
    } 
    XmlAttributeValue xmlAttributeValue = xmlAttribute.getValueElement();
    if (xmlAttributeValue == null) {
      a(xmlTag);
      return;
    } 
    List list1 = DomService.getInstance().getFileElements(Mapper.class, paramProject, GlobalSearchScope.projectScope(paramProject));
    List list2 = (List)list1.stream().map(paramDomFileElement -> paramDomFileElement.getFile().getVirtualFile()).collect(Collectors.toList());
    Query query = ReferencesSearch.search((PsiElement)xmlAttributeValue, (SearchScope)GlobalSearchScope.filesScope(paramProject, list2));
    Collection collection = query.findAll();
    if (collection.isEmpty()) {
      a(xmlTag);
      return;
    } 
    for (PsiReference psiReference : collection) {
      PsiElement psiElement = psiReference.getElement();
      XmlTag xmlTag1 = D.a.a(psiElement, false);
      if (xmlTag1 != null) {
        PsiElement psiElement1 = psiElement.getParent().getParent();
        TextRange textRange1 = psiElement1.getTextRange();
        XmlTagValue xmlTagValue = xmlTag1.getValue();
        String str1 = xmlTagValue.getText();
        TextRange textRange2 = xmlTagValue.getTextRange();
        HashMap<?, ?> hashMap = Maps.newHashMap();
        HashSet<?> hashSet = Sets.newHashSet();
        String str2 = W.a.a(xmlTag1.getChildren(), hashMap, hashSet, true, new TextRange(textRange2.getStartOffset(), textRange1.getStartOffset()));
        String str3 = W.a.a(xmlTag1.getChildren(), hashMap, hashSet, true, new TextRange(textRange1.getEndOffset(), textRange2.getEndOffset()));
        String str4 = " " + W.a.a(str3).trim() + " ";
        String str5 = " " + str2.trim() + " ";
        WriteCommandAction.runWriteCommandAction(paramProject, (Runnable)new Object(this, xmlTag, paramProject, str5, str4));
        return;
      } 
    } 
  }
  
  private void a(XmlTag paramXmlTag) {}
  
  public boolean isAvailable(@NotNull Project paramProject, Editor paramEditor, @NotNull PsiElement paramPsiElement) {
    PsiFile psiFile = paramPsiElement.getContainingFile();
    if (!psiFile.isWritable())
      return false; 
    PsiLanguageInjectionHost psiLanguageInjectionHost = InjectedLanguageManager.getInstance(paramProject).getInjectionHost(paramPsiElement);
    boolean bool = psiLanguageInjectionHost instanceof XmlText;
    if (bool) {
      XmlText xmlText = (XmlText)psiLanguageInjectionHost;
      XmlTag xmlTag = D.a.a((PsiElement)xmlText, true);
      if (xmlTag == null)
        return false; 
      if ("sql".equals(xmlTag.getName())) {
        String str = xmlTag.getValue().getText();
        if (str.contains("@sql"))
          return false; 
        return true;
      } 
    } 
    return false;
  }
  
  @NotNull
  public String getText() {
    return "Add sql prefix and suffix";
  }
}
